#include<stdio.h>
#include<stdlib.h>

struct list_node {
    int data;
    struct list_node *previous, *next;
} *list_pointer;

int create_and_add_node(struct list_node **node, struct list_node* preceding, int number)
{
    struct list_node *new_node = (struct list_node *)malloc(sizeof(struct list_node));
    if(!new_node)
        return -1;
    new_node->data = number;
    new_node->next = *node;
    new_node->previous = preceding;
    if(*node)
        (*node)->previous = new_node;
    *node = new_node;
    return 0;
}

int add_node(struct list_node **node, int number)
{
    struct list_node *preceding = NULL;
    while(*node != NULL && (*node)->data < number) {
        preceding = *node;
        node = &(*node)->next;
    }
    return create_and_add_node(node, preceding, number);
}

void delete_node(struct list_node **node, int number)
{
    while(*node && (*node)->data != number)
        node = &(*node)->next;
    if(*node) {
        struct list_node *temporary = (*node)->next;
        if((*node)->next)
            (*node)->next->previous = (*node)->previous;
        free(*node);
        *node = temporary;
    }
}

void print_list(struct list_node *node)
{
    while(node) {
        printf("%d ", node->data);
        node = node->next;
    }
    puts("");
}

void print_backwards(struct list_node *node)
{
    while(node && node->next)
        node = node->next;
    while (node) {
        printf("%d ", node->data);
        node = node->previous;
    }
    puts("");
}

void remove_list(struct list_node **node)
{
    while(*node) {
        struct list_node *temporary = (*node)->next;
        free(*node);
        *node = temporary;
    }
}

int main(void)
{
    for(int i=1; i<5; i++)
        if(add_node(&list_pointer,i)==-1)
            fprintf(stderr,"Błąd dodawania elementu o wartości %d do listy!\n",i);
    for(int i=6; i<10; i++)
        if(add_node(&list_pointer,i)==-1)
            fprintf(stderr,"Błąd dodawania elementu o wartości %d do listy!\n",i);
    print_list(list_pointer);
    print_backwards(list_pointer);
    if(add_node(&list_pointer,0)==-1)
        fprintf(stderr,"Błąd dodawania elementu o wartości %d do listy!\n",0);
    print_list(list_pointer);
    print_backwards(list_pointer);
    if(add_node(&list_pointer,5)==-1)
        fprintf(stderr,"Błąd dodawania elementu o wartości %d do listy!\n",5);
    print_list(list_pointer);
    print_backwards(list_pointer);
    if(add_node(&list_pointer,7)==-1)
        fprintf(stderr,"Błąd dodawania elementu o wartości %d do listy!\n",7);
    print_list(list_pointer);
    print_backwards(list_pointer);
    if(add_node(&list_pointer,10)==-1)
        fprintf(stderr,"Błąd dodawania elementu o wartości %d do listy!\n",10);
    print_list(list_pointer);
    print_backwards(list_pointer);
    puts("");
    delete_node(&list_pointer,0);
    print_list(list_pointer);
    print_backwards(list_pointer);
    delete_node(&list_pointer,1);
    print_list(list_pointer);
    print_backwards(list_pointer);
    delete_node(&list_pointer,1);
    print_list(list_pointer);
    print_backwards(list_pointer);
    delete_node(&list_pointer,4);
    print_list(list_pointer);
    print_backwards(list_pointer);
    delete_node(&list_pointer,7);
    print_list(list_pointer);
    print_backwards(list_pointer);
    delete_node(&list_pointer,10);
    print_list(list_pointer);
    print_backwards(list_pointer);
    remove_list(&list_pointer);
    return 0;
}
